//-----------------  ᯮ짮 ijl10.dll
//室   ᫥ ᠭ 㭪樨 DLL


extern WINAPI "ijl10.dll"
{
//	int cdecl puts(char *);
//	void cdecl qsort();



/*F*
////////////////////////////////////////////////////////////////////////////
// Name:        ijlGetLibVersion
//
// Purpose:     To identify the version number of the IJL.
//
// Context:     Call to get the IJL version number.
//
// Returns:     pointer to IJLibVersion struct
//
// Parameters:  none
//
////////////////////////////////////////////////////////////////////////////
*F*/

DWORD stdcall  ijlGetLibVersion();




/*F*
////////////////////////////////////////////////////////////////////////////
// Name:        ijlInit
//
// Purpose:     Used to initalize the IJL.
//
//              See the Developer's Guide for details on appropriate usage.
//
// Context:     Always call this before anything else.
//              Also, only call this with a new jcprops structure, or
//              after calling IJL_Free.  Otherwise, dynamically
//              allocated memory may be leaked.
//
// Returns:     Any IJLERR value.  IJL_OK indicates success.
//
// Parameters:
//  jcprops     Pointer to an externally allocated
//              JPEG_CORE_PROPERTIES structure.
//
////////////////////////////////////////////////////////////////////////////
*F*/
DWORD stdcall ijlInit(DWORD);



/*F*
////////////////////////////////////////////////////////////////////////////
// Name:        ijlFree
//
// Purpose:     Used to properly close down the IJL.
//
//              See the Developer's Guide for details on appropriate usage.
//
// Context:     Always call this when done using the IJL to perform
//              clean-up of dynamically allocated memory.
//              Note, IJL_Init will have to be called to use the
//              IJL again.
//
// Returns:     Any IJLERR value.  IJL_OK indicates success.
//
// Parameters:
//  jcprops     Pointer to an externally allocated
//              JPEG_CORE_PROPERTIES structure.
//
////////////////////////////////////////////////////////////////////////////
*F*/
DWORD stdcall ijlFree(DWORD);


/*F*
////////////////////////////////////////////////////////////////////////////
// Name:        IJL_Read
//
// Purpose:     Used to read JPEG data (entropy, or header, or both) into
//              a user-supplied buffer (to hold the image data) and/or
//              into the JPEG_CORE_PROPERTIES structure (to hold the
//              header info).
//
// Context:     See the Developer's Guide for a detailed description
//              on the use of this function.  The jcprops main data
//              members are checked for consistency.
//
// Returns:     Any IJLERR value.  IJL_OK indicates success.
//
// Parameters:
//  jcprops     Pointer to an externally allocated
//              JPEG_CORE_PROPERTIES structure.
//  iotype      Specifies what type of read operation to perform.
//
////////////////////////////////////////////////////////////////////////////
*F*/

//IJLAPI(IJLERR, ijlRead, ( JPEG_CORE_PROPERTIES* jcprops, IJLIOTYPE iotype ));
DWORD stdcall ijlRead(DWORD, DWORD);


}


struct IJLibVersion
{
  int     major;
  int     minor;
  int     build;
  DWORD Name; 			  //LPCTSTR
  DWORD Version;                  //LPCTSTR
  DWORD InternalVersion;          //LPCTSTR
  DWORD BuildDate;                //LPCTSTR
  DWORD CallConv;

};




/*D*
////////////////////////////////////////////////////////////////////////////
// Name:        JPEG_PROPERTIES
//
// Purpose:     Stores low-level and control information.  It is used by
//              both the encoder and decoder.  An advanced external user
//              may access this structure to expand the interface
//              capability.
//
//              See the Developer's Guide for an expanded description
//              of this structure and its use.
//
// Context:     Used by all interface methods and most IJL routines.
//
// Fields:
//
//  iotype              IN:     Specifies type of data operation
//                              (read/write/other) to be
//                              performed by IJL_Read or IJL_Write.
//  roi                 IN:     Rectangle-Of-Interest to read from, or
//                              write to, in pixels.
//  dcttype             IN:     DCT alogrithm to be used.
//  fast_processing     OUT:    Supported fast pre/post-processing path.
//                              This is set by the IJL.
//  interrupt           IN:     Signals an interrupt has been requested.
//
//  DIBBytes            IN:     Pointer to buffer of uncompressed data.
//  DIBWidth            IN:     Width of uncompressed data.
//  DIBHeight           IN:     Height of uncompressed data.
//  DIBPadBytes         IN:     Padding (in bytes) at end of each
//                              row in the uncompressed data.
//  DIBChannels         IN:     Number of components in the
//                              uncompressed data.
//  DIBColor            IN:     Color space of uncompressed data.
//  DIBSubsampling      IN:     Required to be IJL_NONE.
//  DIBLineBytes        OUT:    Number of bytes in an output DIB line
//                              including padding.
//
//  JPGFile             IN:     Pointer to file based JPEG.
//  JPGBytes            IN:     Pointer to buffer based JPEG.
//  JPGSizeBytes        IN:     Max buffer size. Used with JPGBytes.
//                      OUT:    Number of compressed bytes written.
//  JPGWidth            IN:     Width of JPEG image.
//                      OUT:    After reading (except READHEADER).
//  JPGHeight           IN:     Height of JPEG image.
//                      OUT:    After reading (except READHEADER).
//  JPGChannels         IN:     Number of components in JPEG image.
//                      OUT:    After reading (except READHEADER).
//  JPGColor            IN:     Color space of JPEG image.
//  JPGSubsampling      IN:     Subsampling of JPEG image.
//                      OUT:    After reading (except READHEADER).
//  JPGThumbWidth       OUT:    JFIF embedded thumbnail width [0-255].
//  JPGThumbHeight      OUT:    JFIF embedded thumbnail height [0-255].
//
//  cconversion_reqd    OUT:    If color conversion done on decode, TRUE.
//  upsampling_reqd     OUT:    If upsampling done on decode, TRUE.
//  jquality            IN:     [0-100] where highest quality is 100.
//  jinterleaveType     IN/OUT: 0 => MCU interleaved file, and
//                              1 => 1 scan per component.
//  numxMCUs            OUT:    Number of MCUs in the x direction.
//  numyMCUs            OUT:    Number of MCUs in the y direction.
//
//  nqtables            IN/OUT: Number of quantization tables.
//  maxquantindex       IN/OUT: Maximum index of quantization tables.
//  nhuffActables       IN/OUT: Number of AC Huffman tables.
//  nhuffDctables       IN/OUT: Number of DC Huffman tables.
//  maxhuffindex        IN/OUT: Maximum index of Huffman tables.
//  jFmtQuant           IN/OUT: Formatted quantization table info.
//  jFmtAcHuffman       IN/OUT: Formatted AC Huffman table info.
//  jFmtDcHuffman       IN/OUT: Formatted DC Huffman table info.
//
//  jEncFmtQuant        IN/OUT: Pointer to one of the above, or
//                              to externally persisted table.
//  jEncFmtAcHuffman    IN/OUT: Pointer to one of the above, or
//                              to externally persisted table.
//  jEncFmtDcHuffman    IN/OUT: Pointer to one of the above, or
//                              to externally persisted table.
//
//  use_default_qtables IN:     Set to default quantization tables.
//                              Clear to supply your own.
//  use_default_htables IN:     Set to default Huffman tables.
//                              Clear to supply your own.
//  rawquanttables      IN:     Up to 4 sets of quantization tables.
//  rawhufftables       IN:     Alternating pairs (DC/AC) of up to 4
//                              sets of raw Huffman tables.
//  HuffIdentifierAC    IN:     Indicates what channel the user-
//                              supplied Huffman AC tables apply to.
//  HuffIdentifierDC    IN:     Indicates what channel the user-
//                              supplied Huffman DC tables apply to.
//
//  jframe              OUT:    Structure with frame-specific info.
//  needframe           OUT:    TRUE when a frame has been detected.
//
//  jscan               Persistence for current scan pointer when
//                      interrupted.
//
//  state               OUT:    Contains info on the state of the IJL.
//  SawAdobeMarker      OUT:    Decoder saw an APP14 marker somewhere.
//  AdobeXform          OUT:    If SawAdobeMarker TRUE, this indicates
//                              the JPEG color space given by that marker.
//
//  rowoffsets          Persistence for the decoder MCU row origins
//                      when decoding by ROI.  Offsets (in bytes
//                      from the beginning of the entropy data)
//                      to the start of each of the decoded rows.
//                      Fill the offsets with -1 if they have not
//                      been initalized and NULL could be the
//                      offset to the first row.
//
//  MCUBuf              OUT:    Quadword aligned internal buffer.
//                              Big enough for the largest MCU
//                              (10 blocks) with extra room for
//                              additional operations.
//  tMCUBuf             OUT:    Version of above, without alignment.
//
//  processor_type      OUT:    Determines type of processor found
//                              during initialization.
//
//  ignoreDCTs          IN:     Assert to bypass DCTs when processing
//                              data.  Required for conformance
//                              testing.
//
//  progressive_found   OUT:    1 when progressive image detected.
//  coef_buffer         IN:     Pointer to a larger buffer containing
//                              frequency coefficients when they
//                              cannot be decoded dynamically
//                              (i.e., as in progressive decoding).
//
////////////////////////////////////////////////////////////////////////////
*D*/

/*
typedef struct
{
  // Compression/Decompression control.
  IJLIOTYPE                iotype;               // default = IJL_SETUP
  RECT                     roi;                  // default = 0
  DCTTYPE                  dcttype;              // default = IJL_AAN
  FAST_MCU_PROCESSING_TYPE fast_processing;      // default = IJL_NO_CC_OR_US
  DWORD                    interrupt;            // default = FALSE

  // DIB specific I/O data specifiers.
  BYTE*                    DIBBytes;             // default = NULL
  DWORD                    DIBWidth;             // default = 0
  int                      DIBHeight;            // default = 0
  DWORD                    DIBPadBytes;          // default = 0
  DWORD                    DIBChannels;          // default = 3
  IJL_COLOR                DIBColor;             // default = IJL_BGR
  IJL_DIBSUBSAMPLING       DIBSubsampling;       // default = IJL_NONE
  int                      DIBLineBytes;         // default = 0

  // JPEG specific I/O data specifiers.
  LPTSTR                   JPGFile;              // default = NULL
  BYTE*                    JPGBytes;             // default = NULL
  DWORD                    JPGSizeBytes;         // default = 0
  DWORD                    JPGWidth;             // default = 0
  DWORD                    JPGHeight;            // default = 0
  DWORD                    JPGChannels;          // default = 3
  IJL_COLOR                JPGColor;             // default = IJL_YCBCR
  IJL_JPGSUBSAMPLING       JPGSubsampling;       // default = IJL_411
  DWORD                    JPGThumbWidth;        // default = 0
  DWORD                    JPGThumbHeight;       // default = 0

  // JPEG conversion properties.
  DWORD                    cconversion_reqd;     // default = TRUE
  DWORD                    upsampling_reqd;      // default = TRUE
  DWORD                    jquality;             // default = 75
  DWORD                    jinterleaveType;      // default = 0
  DWORD                    numxMCUs;             // default = 0
  DWORD                    numyMCUs;             // default = 0

  // Tables.
  DWORD                    nqtables;
  DWORD                    maxquantindex;
  DWORD                    nhuffActables;
  DWORD                    nhuffDctables;
  DWORD                    maxhuffindex;

  QUANT_TABLE              jFmtQuant[4];
  HUFFMAN_TABLE            jFmtAcHuffman[4];
  HUFFMAN_TABLE            jFmtDcHuffman[4];

  short*                   jEncFmtQuant[4];
  HUFFMAN_TABLE*           jEncFmtAcHuffman[4];
  HUFFMAN_TABLE*           jEncFmtDcHuffman[4];

  // Allow user-defined tables.
  DWORD                    use_default_qtables;
  DWORD                    use_default_htables;

  JPEGQuantTable           rawquanttables[4];
  JPEGHuffTable            rawhufftables[8];
  BYTE                     HuffIdentifierAC[4];
  BYTE                     HuffIdentifierDC[4];

  // Frame specific members.
  FRAME                    jframe;
  int                      needframe;

  // SCAN persistent members.
  SCAN*                    jscan;

  // State members.
  STATE                    state;
  DWORD                    SawAdobeMarker;
  DWORD                    AdobeXform;

  // ROI decoder members.
  ENTROPYSTRUCT*           rowoffsets;

  // Intermediate buffers.
  BYTE*                    MCUBuf;
  BYTE                     tMCUBuf[720*2];       // ???

  // Processor detected.
  PROCESSOR_TYPE           processor_type;

  // Test specific members.
  DWORD                    ignoreDCTs;

  // Progressive mode members.
  int                      progressive_found;
  short*                   coef_buffer;

} JPEG_PROPERTIES;
*/


//19944/4=4986


/*D*
////////////////////////////////////////////////////////////////////////////
// Name:        JPEG_CORE_PROPERTIES
//
// Purpose:     This is the primary data structure between the IJL and
//              the external user.  It stores JPEG state information
//              and controls the IJL.  It is user-modifiable.
//
//              See the Developer's Guide for details on appropriate usage.
//
// Context:     Used by all low-level IJL routines to store
//              pseudo-global information.
//
// Fields:
//
//  UseJPEGPROPERTIES   Set this flag != 0 if you wish to override
//                      the JPEG_CORE_PROPERTIES "IN" parameters with
//                      the JPEG_PROPERTIES parameters.
//
//  DIBBytes            IN:     Pointer to buffer of uncompressed data.
//  DIBWidth            IN:     Width of uncompressed data.
//  DIBHeight           IN:     Height of uncompressed data.
//  DIBPadBytes         IN:     Padding (in bytes) at end of each
//                              row in the uncompressed data.
//  DIBChannels         IN:     Number of components in the
//                              uncompressed data.
//  DIBColor            IN:     Color space of uncompressed data.
//  DIBSubsampling      IN:     Required to be IJL_NONE.
//
//  JPGFile             IN:     Pointer to file based JPEG.
//  JPGBytes            IN:     Pointer to buffer based JPEG.
//  JPGSizeBytes        IN:     Max buffer size. Used with JPGBytes.
//                      OUT:    Number of compressed bytes written.
//  JPGWidth            IN:     Width of JPEG image.
//                      OUT:    After reading (except READHEADER).
//  JPGHeight           IN:     Height of JPEG image.
//                      OUT:    After reading (except READHEADER).
//  JPGChannels         IN:     Number of components in JPEG image.
//                      OUT:    After reading (except READHEADER).
//  JPGColor            IN:     Color space of JPEG image.
//  JPGSubsampling      IN:     Subsampling of JPEG image.
//                      OUT:    After reading (except READHEADER).
//  JPGThumbWidth       OUT:    JFIF embedded thumbnail width [0-255].
//  JPGThumbHeight      OUT:    JFIF embedded thumbnail height [0-255].
//
//  cconversion_reqd    OUT:    If color conversion done on decode, TRUE.
//  upsampling_reqd     OUT:    If upsampling done on decode, TRUE.
//  jquality            IN:     [0-100] where highest quality is 100.
//
//  jprops              "Low-Level" IJL data structure.
//
////////////////////////////////////////////////////////////////////////////
*D*/

struct JPEG_CORE_PROPERTIES
{
  DWORD   UseJPEGPROPERTIES;                     // default = 0

  // DIB specific I/O data specifiers.
  DWORD               DIBBytes;                  // default = NULL
  DWORD               DIBWidth;                  // default = 0
  DWORD               DIBHeight;                 // default = 0
  DWORD               DIBPadBytes;               // default = 0
  DWORD               DIBChannels;               // default = 3
  DWORD               DIBColor;                  // default = IJL_BGR
  DWORD               DIBSubsampling;            // default = IJL_NONE

  // JPEG specific I/O data specifiers.
  DWORD               JPGFile;                   // default = NULL //LPTSTR 
  DWORD               JPGBytes;                  // default = NULL
  DWORD               JPGSizeBytes;              // default = 0
  DWORD               JPGWidth;                  // default = 0
  DWORD               JPGHeight;                 // default = 0
  DWORD               JPGChannels;               // default = 3
  DWORD               JPGColor;                  // default = IJL_YCBCR
  DWORD               JPGSubsampling;            // default = IJL_411
  DWORD               JPGThumbWidth;             // default = 0
  DWORD               JPGThumbHeight;            // default = 0

  // JPEG conversion properties.
  DWORD               cconversion_reqd;          // default = TRUE
  DWORD               upsampling_reqd;           // default = TRUE
  DWORD               jquality;                  // default = 75

  // Low-level properties.
//  JPEG_PROPERTIES     jprops;
  byte	              JPEG_PROPERTIES[19944];   //   ᥩ  JPEG_PROPERTIES
  DWORD               KTOEGOZNAET;              //    㦭.
};


#define  IJL_OK                      0;
#define  IJL_JFILE_READPARAMS 	     0;
#define	 IJL_JFILE_READWHOLEIMAGE    2;
#define  IJL_RGB 		     1; 





